// Code generated by mockery v2.20.0. DO NOT EDIT.

package mocks

import (
	context "context"
	http "net/http"

	mock "github.com/stretchr/testify/mock"

	ubiquity "gitlab.com/Blockdaemon/ubiquity/ubiquity-go-client/v1/pkg/client"
)

// GasEstimatorAPI is an autogenerated mock type for the GasEstimatorAPI type
type GasEstimatorAPI struct {
	mock.Mock
}

// GetGasFeeEstimate provides a mock function with given fields: ctx, protocol, network
func (_m *GasEstimatorAPI) GetGasFeeEstimate(ctx context.Context, protocol string, network string) ubiquity.ApiGetGasFeeEstimateRequest {
	ret := _m.Called(ctx, protocol, network)

	var r0 ubiquity.ApiGetGasFeeEstimateRequest
	if rf, ok := ret.Get(0).(func(context.Context, string, string) ubiquity.ApiGetGasFeeEstimateRequest); ok {
		r0 = rf(ctx, protocol, network)
	} else {
		r0 = ret.Get(0).(ubiquity.ApiGetGasFeeEstimateRequest)
	}

	return r0
}

// GetGasFeeEstimateExecute provides a mock function with given fields: r
func (_m *GasEstimatorAPI) GetGasFeeEstimateExecute(r ubiquity.ApiGetGasFeeEstimateRequest) (ubiquity.FeeEstimate, *http.Response, error) {
	ret := _m.Called(r)

	var r0 ubiquity.FeeEstimate
	var r1 *http.Response
	var r2 error
	if rf, ok := ret.Get(0).(func(ubiquity.ApiGetGasFeeEstimateRequest) (ubiquity.FeeEstimate, *http.Response, error)); ok {
		return rf(r)
	}
	if rf, ok := ret.Get(0).(func(ubiquity.ApiGetGasFeeEstimateRequest) ubiquity.FeeEstimate); ok {
		r0 = rf(r)
	} else {
		r0 = ret.Get(0).(ubiquity.FeeEstimate)
	}

	if rf, ok := ret.Get(1).(func(ubiquity.ApiGetGasFeeEstimateRequest) *http.Response); ok {
		r1 = rf(r)
	} else {
		if ret.Get(1) != nil {
			r1 = ret.Get(1).(*http.Response)
		}
	}

	if rf, ok := ret.Get(2).(func(ubiquity.ApiGetGasFeeEstimateRequest) error); ok {
		r2 = rf(r)
	} else {
		r2 = ret.Error(2)
	}

	return r0, r1, r2
}

type mockConstructorTestingTNewGasEstimatorAPI interface {
	mock.TestingT
	Cleanup(func())
}

// NewGasEstimatorAPI creates a new instance of GasEstimatorAPI. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
func NewGasEstimatorAPI(t mockConstructorTestingTNewGasEstimatorAPI) *GasEstimatorAPI {
	mock := &GasEstimatorAPI{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
